/*
 * PM - 2016
 * Mihai-Cristian Gogosila , 335CC
 */

#define F_CPU 16000000
 
#include <avr/io.h>
#include <util/delay.h>


float frecventa_nota[8] = {
	261.63, 293.66, 329.63, 349.23, 392.0, 440.0, 493.88, 523.25
};

void buzzer(float durata , float frecv){
	float perioada = 1000/frecv;
	int i , c;
	DDRC |= (1<<PC7);
	c = durata / perioada ;
	for ( i = 0 ; i < c ; i++){
		_delay_ms((double)perioada/2);
		PORTC |= (1<<PC7);
		_delay_ms((double)perioada/2);
		PORTC &= ~(1<<PC7);
	}
	PORTC &= ~(1<<PC7);
}

void luminare1(void) {

	PORTA |= (1 << PA7);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTA &= ~(1 << PA7);

	PORTA |= (1 << PA6);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTA &= ~(1 << PA6);
	
	PORTA |= (1 << PA6);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTA &= ~(1 << PA6);
	
	PORTA |= (1 << PA5);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTA &= ~(1 << PA5);
	
	PORTA |= (1 << PA4);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTA &= ~(1 << PA4);
	
	PORTA |= (1 << PA3);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTA &= ~(1 << PA3);
	
	PORTA |= (1 << PA2);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTA &= ~(1 << PA2);
	
	PORTA |= (1 << PA1);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTA &= ~(1 << PA1);

	PORTA |= (1 << PA0);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTA &= ~(1 << PA0);

	PORTC |= (1 << PC0);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTC &= ~(1 << PC0);

	PORTC |= (1 << PC1);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);

	PORTC |= (1 << PC2);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);

	PORTC |= (1 << PC3);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);

	PORTC |= (1 << PC4);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

	PORTD |= (1 << PD7);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTD &= ~(1 << PC7);

	PORTD |= (1 << PD6);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTD &= ~(1 << PC6);

	PORTD |= (1 << PD5);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTD &= ~(1 << PD5);

	PORTD |= (1 << PD4);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTD &= ~(1 << PD4);

	PORTD |= (1 << PD3);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTD &= ~(1 << PD3);

	PORTD |= (1 << PD2);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTD &= ~(1 << PD2);

	PORTD |= (1 << PD1);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTD &= ~(1 << PD1);

	PORTD |= (1 << PD0);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTD &= ~(1 << PD0);

	PORTB |= (1 << PB7);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTB &= ~(1 << PB7);

	PORTB |= (1 << PB6);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTB &= ~(1 << PB6);

	PORTB |= (1 << PB5);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTB &= ~(1 << PB5);

	PORTB |= (1 << PB4);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTB &= ~(1 << PB4);

	PORTB |= (1 << PB3);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTB &= ~(1 << PB3);

	PORTB |= (1 << PB2);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTB &= ~(1 << PB2);

	PORTB |= (1 << PB1);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTB &= ~(1 << PB1);

	PORTB |= (1 << PB0);
	buzzer(200 , frecventa_nota[rand()%8]);
	_delay_ms(100);
	PORTB &= ~(1 << PB0);
}

void luminare2(void){

	PORTA |= (1 << PA7);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA2);
	PORTC |= (1 << PC0);
	PORTC |= (1 << PC3);
	PORTD |= (1 << PD6);
	PORTD |= (1 << PD3);
	PORTD |= (1 << PD0);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB2);
	_delay_ms(1000);
	PORTA &= ~(1 << PA7);
	PORTA &= ~(1 << PA5);
	PORTA &= ~(1 << PA2);
	PORTC &= ~(1 << PC0);
	PORTC &= ~(1 << PC3);
	PORTD &= ~(1 << PD6);
	PORTD &= ~(1 << PD3);
	PORTD &= ~(1 << PD0);
	PORTB &= ~(1 << PB5);
	PORTB &= ~(1 << PB2);
}

void luminare3(void){

	PORTA |= (1 << PA6);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA1);
	PORTC |= (1 << PC1);
	PORTC |= (1 << PC4);
	PORTD |= (1 << PD5);
	PORTD |= (1 << PD2);
	PORTB |= (1 << PB7);
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB1);
	_delay_ms(1000);
	PORTA &= ~(1 << PA6);
	PORTA &= ~(1 << PA4);
	PORTA &= ~(1 << PA1);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC4);
	PORTD &= ~(1 << PD5);
	PORTD &= ~(1 << PD2);
	PORTB &= ~(1 << PB7);
	PORTB &= ~(1 << PB4);
	PORTB &= ~(1 << PB1);
}

void luminare4(void){

	PORTA |= (1 << PA3);
	PORTA |= (1 << PA0);
	PORTC |= (1 << PC2);
	PORTD |= (1 << PD7);
	PORTD |= (1 << PD4);
	PORTD |= (1 << PD1);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB3);
	PORTB |= (1 << PB0);
	_delay_ms(1000);
	PORTA &= ~(1 << PA3);
	PORTA &= ~(1 << PA0);
	PORTC &= ~(1 << PC2);
	PORTD &= ~(1 << PD7);
	PORTD &= ~(1 << PD4);
	PORTD &= ~(1 << PD1);
	PORTB &= ~(1 << PB6);
	PORTB &= ~(1 << PB3);
	PORTB &= ~(1 << PB0);
}

void luminare5(void){


	PORTB |= (1 << PB0);
	_delay_ms(100);
	PORTB &= ~(1 << PB0);
	
	PORTB |= (1 << PB1);
	_delay_ms(100);
	PORTB &= ~(1 << PB1);

	PORTB |= (1 << PB2);
	_delay_ms(100);
	PORTB &= ~(1 << PB2);

	PORTB |= (1 << PB3);
	_delay_ms(100);
	PORTB &= ~(1 << PB3);

	PORTB |= (1 << PB4);
	_delay_ms(100);
	PORTB &= ~(1 << PB4);

	PORTB |= (1 << PB5);
	_delay_ms(100);
	PORTB &= ~(1 << PB5);

	PORTB |= (1 << PB6);
	_delay_ms(100);
	PORTB &= ~(1 << PB6);

	PORTB |= (1 << PB7);
	_delay_ms(100);
	PORTB &= ~(1 << PB7);

	PORTD |= (1 << PD0);
	_delay_ms(100);
	PORTD &= ~(1 << PD0);

	PORTD |= (1 << PD1);
	_delay_ms(100);
	PORTD &= ~(1 << PD1);

	PORTD |= (1 << PD2);
	_delay_ms(100);
	PORTD &= ~(1 << PD2);

	PORTD |= (1 << PD3);
	_delay_ms(100);
	PORTD &= ~(1 << PD3);

	PORTD |= (1 << PD4);
	_delay_ms(100);
	PORTD &= ~(1 << PD4);

	PORTD |= (1 << PD5);
	_delay_ms(100);
	PORTD &= ~(1 << PD5);

	PORTD |= (1 << PD6);
	_delay_ms(100);
	PORTD &= ~(1 << PC6);

	PORTD |= (1 << PD7);
	_delay_ms(100);
	PORTD &= ~(1 << PC7);

	PORTC |= (1 << PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

	PORTC |= (1 << PC3);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);

	PORTC |= (1 << PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);

	PORTC |= (1 << PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);

	PORTC |= (1 << PC0);
	_delay_ms(100);
	PORTC &= ~(1 << PC0);

	PORTA |= (1 << PA0);
	_delay_ms(100);
	PORTA &= ~(1 << PA0);
	
	PORTA |= (1 << PA1);
	_delay_ms(100);
	PORTA &= ~(1 << PA1);
	
	PORTA |= (1 << PA2);
	_delay_ms(100);
	PORTA &= ~(1 << PA2);
	
	PORTA |= (1 << PA3);
	_delay_ms(100);
	PORTA &= ~(1 << PA3);
	
	PORTA |= (1 << PA4);
	_delay_ms(100);
	PORTA &= ~(1 << PA4);
	
	PORTA |= (1 << PA5);
	_delay_ms(100);
	PORTA &= ~(1 << PA5);
	
	PORTA |= (1 << PA6);
	_delay_ms(100);
	PORTA &= ~(1 << PA6);

	PORTA |= (1 << PA7);
	_delay_ms(100);
	PORTA &= ~(1 << PA7);	
}

void luminare6(void){

	PORTA |= (1 << PA1);
	PORTB |= (1 << PB3);
	PORTB |= (1 << PB2);
	PORTD |= (1 << PD0);
	PORTB |= (1 << PB4);
	_delay_ms(300);
	PORTA &= ~(1 << PA1);
	PORTB &= ~(1 << PB2);
	PORTB &= ~(1 << PB3);
	PORTB &= ~(1 << PB4);
	PORTD &= ~(1 << PD0);
}

void luminare7(void){

	PORTB |= (1 << PB5);
	PORTA |= (1 << PA7);
	PORTA |= (1 << PA0);
	PORTC |= (1 << PC1);
	PORTD |= (1 << PD6);
	_delay_ms(300);
	PORTB &= ~(1 << PB5);
	PORTA &= ~(1 << PA7);
	PORTA &= ~(1 << PA0);
	PORTC &= ~(1 << PC1);
	PORTD &= ~(1 << PD6);
}

void luminare8(void){

	PORTD |= (1 << PD3);
	PORTD |= (1 << PD5);
	PORTC |= (1 << PC4);
	PORTA |= (1 << PA3);
	PORTB |= (1 << PB7);
	_delay_ms(300);
	PORTD &= ~(1 << PD3);
	PORTD &= ~(1 << PD5);
	PORTC &= ~(1 << PC4);
	PORTA &= ~(1 << PA3);
	PORTB &= ~(1 << PB7);
}

void luminare9(void){

	PORTC |= (1 << PC2);
	PORTD |= (1 << PD7);
	PORTD |= (1 << PD2);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB1);
	_delay_ms(300);
	PORTC &= ~(1 << PC2);
	PORTB &= ~(1 << PB1);
	PORTB &= ~(1 << PB6);
	PORTD &= ~(1 << PD2);
	PORTD &= ~(1 << PD7);
}

void luminare10(void){

	PORTA |= (1 << PA6);
	PORTA |= (1 << PA5);
	PORTC |= (1 << PC0);
	PORTD |= (1 << PD4);
	PORTB |= (1 << PB0);
	_delay_ms(300);
	PORTA &= ~(1 << PA5);
	PORTC &= ~(1 << PC0);
	PORTA &= ~(1 << PA6);
	PORTB &= ~(1 << PB0);
	PORTD &= ~(1 << PD4);
}

void luminare11(void){

	PORTA |= (1 << PA4);
	PORTA |= (1 << PA2);
	PORTC |= (1 << PC3);
	PORTD |= (1 << PD1);
	_delay_ms(300);
	PORTA &= ~(1 << PA4);
	PORTA &= ~(1 << PA2);
	PORTC &= ~(1 << PC3);
	PORTD &= ~(1 << PD1);
}

int main(void) {

	//pentru folosire PORTC
	MCUCR |= (1 << JTD);
	MCUCR |= (1 << JTD);

	//setare PORTD
	DDRD |= (1 << PD7);
	DDRD |= (1 << PD6);
	DDRD |= (1 << PD5);
	DDRD |= (1 << PD4);
	DDRD |= (1 << PD3);
	DDRD |= (1 << PD2);
	DDRD |= (1 << PD1);
	DDRD |= (1 << PD0);

	//setare PORTA
	DDRA |= (1 << PA7);
	DDRA |= (1 << PA6);
	DDRA |= (1 << PA5);
	DDRA |= (1 << PA4);
	DDRA |= (1 << PA3);
	DDRA |= (1 << PA2);
	DDRA |= (1 << PA1);
	DDRA |= (1 << PA0);

	//setare PORTB
	DDRB |= (1 << PB7);
	DDRB |= (1 << PB6);
	DDRB |= (1 << PB5);
	DDRB |= (1 << PB4);
	DDRB |= (1 << PB3);
	DDRB |= (1 << PB2);
	DDRB |= (1 << PB1);
	DDRB |= (1 << PB0);

	//setare PORTC
	DDRC |= (1 << PC4);
	DDRC |= (1 << PC3);
	DDRC |= (1 << PC2);
	DDRC |= (1 << PC1);
	DDRC |= (1 << PC0);


	//iluminare
	while(1){
		luminare1();
		luminare2();
		luminare3();
		luminare4();
		luminare5();
		luminare6();
		luminare7();
		luminare8();
		luminare9();
		luminare10();
		luminare11();
		luminare5();
	}


	return 0;
}
